/**
 * POCDMT000040ManufacturedProduct.java
 *
 * File generated from the cda::POCDMT000040ManufacturedProduct uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaxehealth;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import net.ihe.gazelle.ips.datatypes.CS;
import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class POCDMT000040ManufacturedProduct.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.ManufacturedProduct", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"manufacturedLabeledDrug",
	"manufacturedMaterial",
	"manufacturerOrganization",
	"classCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.ManufacturedProduct")
public class POCDMT000040ManufacturedProduct implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<CS > realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.II> id;
	@XmlElement(name = "manufacturedLabeledDrug", namespace = "urn:hl7-org:v3")
	public POCDMT000040LabeledDrug manufacturedLabeledDrug;
	@XmlElement(name = "manufacturedMaterial", namespace = "urn:hl7-org:v3")
	public POCDMT000040Material manufacturedMaterial;
	@XmlElement(name = "manufacturerOrganization", namespace = "urn:hl7-org:v3")
	public POCDMT000040Organization manufacturerOrganization;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.RoleClassManufacturedProduct classCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlTransient
	private Object __parent;
	
	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this.__parent = parent;
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<CS > getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<CS >();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<CS > realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.ips.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.ips.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.ips.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.ips.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.ips.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public List<net.ihe.gazelle.ips.datatypes.II> getId() {
		if (id == null) {
	        id = new ArrayList<net.ihe.gazelle.ips.datatypes.II>();
	    }
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(List<net.ihe.gazelle.ips.datatypes.II> id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Add a id to the id collection.
	 * @param id_elt Element to add.
	 */
	public void addId(net.ihe.gazelle.ips.datatypes.II id_elt) {
	    this.getId().add(id_elt);
	}
	
	/**
	 * Remove a id to the id collection.
	 * @param id_elt Element to remove
	 */
	public void removeId(net.ihe.gazelle.ips.datatypes.II id_elt) {
	    this.getId().remove(id_elt);
	}
	
	/**
	 * Return manufacturedLabeledDrug.
	 * @return manufacturedLabeledDrug
	 */
	public POCDMT000040LabeledDrug getManufacturedLabeledDrug() {
	    return manufacturedLabeledDrug;
	}
	
	/**
	 * Set a value to attribute manufacturedLabeledDrug.
	 * @param manufacturedLabeledDrug.
	 */
	public void setManufacturedLabeledDrug(POCDMT000040LabeledDrug manufacturedLabeledDrug) {
	    this.manufacturedLabeledDrug = manufacturedLabeledDrug;
	}
	
	
	
	
	/**
	 * Return manufacturedMaterial.
	 * @return manufacturedMaterial
	 */
	public POCDMT000040Material getManufacturedMaterial() {
	    return manufacturedMaterial;
	}
	
	/**
	 * Set a value to attribute manufacturedMaterial.
	 * @param manufacturedMaterial.
	 */
	public void setManufacturedMaterial(POCDMT000040Material manufacturedMaterial) {
	    this.manufacturedMaterial = manufacturedMaterial;
	}
	
	
	
	
	/**
	 * Return manufacturerOrganization.
	 * @return manufacturerOrganization
	 */
	public POCDMT000040Organization getManufacturerOrganization() {
	    return manufacturerOrganization;
	}
	
	/**
	 * Set a value to attribute manufacturerOrganization.
	 * @param manufacturerOrganization.
	 */
	public void setManufacturerOrganization(POCDMT000040Organization manufacturerOrganization) {
	    this.manufacturerOrganization = manufacturerOrganization;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.RoleClassManufacturedProduct getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.RoleClassManufacturedProduct classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return __parent.
	 * @return __parent
	 */
	public Object get__parent() {
	    return __parent;
	}
	
	/**
	 * Set a value to attribute __parent.
	 * @param __parent.
	 */
	public void set__parent(Object __parent) {
	    this.__parent = __parent;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaxehealth");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.ManufacturedProduct").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040ManufacturedProduct pOCDMT000040ManufacturedProduct, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040ManufacturedProduct != null){
   			cvm.validate(pOCDMT000040ManufacturedProduct, _location, diagnostic);
			{
				int i = 0;
				for (CS realmCode: pOCDMT000040ManufacturedProduct.getRealmCode()){
					CS .validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040ManufacturedProduct.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.II templateId: pOCDMT000040ManufacturedProduct.getTemplateId()){
					net.ihe.gazelle.ips.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.II id: pOCDMT000040ManufacturedProduct.getId()){
					net.ihe.gazelle.ips.datatypes.II.validateByModule(id, _location + "/id[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040LabeledDrug.validateByModule(pOCDMT000040ManufacturedProduct.getManufacturedLabeledDrug(), _location + "/manufacturedLabeledDrug", cvm, diagnostic);
			POCDMT000040Material.validateByModule(pOCDMT000040ManufacturedProduct.getManufacturedMaterial(), _location + "/manufacturedMaterial", cvm, diagnostic);
			POCDMT000040Organization.validateByModule(pOCDMT000040ManufacturedProduct.getManufacturerOrganization(), _location + "/manufacturerOrganization", cvm, diagnostic);
    	}
    }

}